//++
//|                                                JQS UGA_script v1.1.0 |
//|                                       Copyright  2010, JQS aka Joo. |
//|                                     http://www.mql4.com/ru/users/joo |
//++
#property copyright "Copyright  2010, JQS aka Joo."                   //|
#property link      "http://www.mql4.com/ru/users/joo"                 //|
//++
#property description ",   "      //|
#property description "   UGAlib," //|
#property description "  "          //|
#property description " "                          //|
//++
#property script_show_inputs                                           //|
//++
#include "UGAlib v1.2.1.mqh"
#include "StrangeProblem.mqh"
//++

//
//---------------------- --------------------------------
input double AAAA                  =2.5;
input string GenofundParam         =        "---- ----";
input int    ChromosomeCount_P     = 200;    //-   
input int    GeneCount_P           = 7;     //- 
input int    Epoch_P               = 100;    //-   
//---
input string GA_OperatorParam      =        "---- ----";
input double ReplicationPortion_P  = 100.0; // .
input double NMutationPortion_P    = 100.0;  //  .
input double ArtificialMutation_P  = 20.0;  //  .
input double GenoMergingPortion_P  = 20.0;  //  .
input double CrossingOverPortion_P = 20.0;  // .
//---
input double ReplicationOffset_P   = 1.5;   //   
input double NMutationProbability_P= 30.0;   //     %
//---
input string OptimisationParam     =        "---- ----";
input double RangeMinimum_P        = -10.0;  //  
input double RangeMaximum_P        = 10.0;   //  
input double Precision_P           = 0.00000001;// 
input int    OptimizeMethod_P      = 1;     //.:1-Min,-Max
//

double A[20] ={11,12,16,19,23,25,26,27,29,34,37,38,43,46,48,58,59,62,64,73};
double B[20] ={ 2,3 ,7 ,9 ,11,16,18,31,32,33,41,42,43,47,53,54,60,61,64,81};
double C[20] ={ 7,9 ,15,22,24,25,27,28,29,34,42,44,46,52,53,64,66,67,68,70};
double D[20] ={ 1,5 ,4 ,15,18,19,24,32,34,39,42,46,47,48,49,60,61,68,72,77};
double E[20] ={ 9,12,19,21,24,27,29,35,43,45,46,55,58,61,64,65,66,68,71,82};
double F[20] ={ 6,11,12,22,26,32,42,48,52,54,58,61,64,65,72,83,84,87,94,97};
double G[20] ={ 4,9 ,14,15,19,26,35,37,39,40,45,48,52,53,59,63,67,70,74,76};

//A + B + C + D + E + F + G = 256

//
//---------------------- -----------------------------
double ERROR=0.0;//   
//
int Count=20;
//
//-------------------------- --------------------------------
int OnStart()
{
  //------------------------------------------------------------
  //    UGA
  ChromosomeCount=ChromosomeCount_P; //-   
  GeneCount      =GeneCount_P;       //- 
  RangeMinimum   =RangeMinimum_P;    //  
  RangeMaximum   =RangeMaximum_P;    //  
  Precision      =Precision_P;       // 
  OptimizeMethod =OptimizeMethod_P;  //1-,  -
  ArrayResize(Chromosome,GeneCount+1);
  ArrayInitialize(Chromosome,0);
  Epoch=Epoch_P;                     //-   
  //----------------------------------------------------------------------
  // 
  int time_start=GetTickCount(),time_end=0;
  //----------------------------------------------------------------------

  //  - UGA
  UGA
  (
  ReplicationPortion_P, // .
  NMutationPortion_P,   //  .
  ArtificialMutation_P, //  .
  GenoMergingPortion_P, //  .
  CrossingOverPortion_P,// .
  //---
  ReplicationOffset_P,  //   
  NMutationProbability_P//     %
  );

  /*
  Print("1  ",AAAA);
  double a=  Scale(AAAA,RangeMinimum_P,RangeMaximum_P,A[0],A[Count-1]);
  Print("2  ",a);
  a=Digitization(a,A,Count);
  Print("3  ",a);
  */
  //Print(Digitization(68.9, A,Count));
  //----------------------------------
  time_end=GetTickCount();
  //----------------------------------
  Print(time_end-time_start,"  -  ");
  //----------------------------------
  return(0);
}
//
