//+------------------------------------------------------------------+
//|                                               StrangeProblem.mqh |
//|                                      Copyright 2010, JQS aka Joo |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, JQS aka Joo"

void FitnessFunction(int chromos)
{
  double a=  Scale(Colony[1][chromos],RangeMinimum_P,RangeMaximum_P,A[0],A[Count-1]);
  a=Digitization(a,A,Count);

  double b=  Scale(Colony[2][chromos],RangeMinimum_P,RangeMaximum_P,B[0],B[Count-1]);
  b=Digitization(b,B,Count);

  double c=  Scale(Colony[3][chromos],RangeMinimum_P,RangeMaximum_P,C[0],C[Count-1]);
  c=Digitization(c,C,Count);

  double d=  Scale(Colony[4][chromos],RangeMinimum_P,RangeMaximum_P,D[0],D[Count-1]);
  d=Digitization(d,D,Count);

  double e=  Scale(Colony[5][chromos],RangeMinimum_P,RangeMaximum_P,E[0],E[Count-1]);
  e=Digitization(e,E,Count);

  double f=  Scale(Colony[6][chromos],RangeMinimum_P,RangeMaximum_P,F[0],F[Count-1]);
  f=Digitization(f,F,Count);

  double g=  Scale(Colony[7][chromos],RangeMinimum_P,RangeMaximum_P,G[0],G[Count-1]);
  g=Digitization(g,G,Count);


  AmountStartsFF++;
  Colony[0][chromos]=MathAbs((a+b+c+d+e+f+g)-256.0);
  //Comment(Colony[0][chromos]);
  //Sleep(500);
}
//
void ServiceFunction()
{ 
  
  string Str=
  Digitization(Scale(Chromosome[1],RangeMinimum_P,RangeMaximum_P,A[0],A[Count-1]),A,Count)+"+"+
  Digitization(Scale(Chromosome[2],RangeMinimum_P,RangeMaximum_P,B[0],B[Count-1]),B,Count)+"+"+
  Digitization(Scale(Chromosome[3],RangeMinimum_P,RangeMaximum_P,C[0],C[Count-1]),C,Count)+"+"+
  Digitization(Scale(Chromosome[4],RangeMinimum_P,RangeMaximum_P,D[0],D[Count-1]),D,Count)+"+"+
  Digitization(Scale(Chromosome[5],RangeMinimum_P,RangeMaximum_P,E[0],E[Count-1]),E,Count)+"+"+
  Digitization(Scale(Chromosome[6],RangeMinimum_P,RangeMaximum_P,F[0],F[Count-1]),F,Count)+"+"+
  Digitization(Scale(Chromosome[7],RangeMinimum_P,RangeMaximum_P,G[0],G[Count-1]),G,Count)+"="+
  (Chromosome[0]+256.0);
  Comment(Str);
  /*
  string Str="";
  for(int i=0;i<100;i++)
  {
    Str+=
  Digitization(Scale(Population[1][i],RangeMinimum_P,RangeMaximum_P,A[0],A[Count-1]),A,Count)+"+"+
  Digitization(Scale(Population[2][i],RangeMinimum_P,RangeMaximum_P,B[0],B[Count-1]),B,Count)+"+"+
  Digitization(Scale(Population[3][i],RangeMinimum_P,RangeMaximum_P,C[0],C[Count-1]),C,Count)+"+"+
  Digitization(Scale(Population[4][i],RangeMinimum_P,RangeMaximum_P,D[0],D[Count-1]),D,Count)+"+"+
  Digitization(Scale(Population[5][i],RangeMinimum_P,RangeMaximum_P,E[0],E[Count-1]),E,Count)+"+"+
  Digitization(Scale(Population[6][i],RangeMinimum_P,RangeMaximum_P,F[0],F[Count-1]),F,Count)+"+"+
  Digitization(Scale(Population[7][i],RangeMinimum_P,RangeMaximum_P,G[0],G[Count-1]),G,Count)+"="+
  (Chromosome[0]+256.0)+"\n";
  }
  Comment(Str);
  */
}
//
//
double Digitization(double Input, double &DiscreteSpace[],int count)
{
  if (Input<DiscreteSpace[0])
    return(DiscreteSpace[0]);
  if (Input>DiscreteSpace[count-1])
    return(DiscreteSpace[count-1]);

  for (int i=0;i<count-1;i++)
  {
    if (DiscreteSpace[i]<=Input && Input<=DiscreteSpace[i+1])
    {
      if (Input-DiscreteSpace[i]<DiscreteSpace[i+1]-Input)
      {
        return(DiscreteSpace[i]);
        //Print(" 1");
      }
      else
      {
        return(DiscreteSpace[i+1]);
        //Print(" 2");
      }
    }
    //Print("  ",i);
  }
  Alert(" .    - ,     !");
  Alert("...    ...    . :(");
  return(0.0);
}
//
//
double Scale(double In,double InMIN,double InMAX,double OutMIN,double OutMAX)
{
  if (In>InMAX)       return(OutMAX);
  if (In<InMIN)       return(OutMIN);
  if (OutMIN==OutMAX) return(OutMIN);
  if (InMAX==InMIN)   return((OutMAX+OutMIN)/2.0);
  return(((In-InMIN)*(OutMAX-OutMIN)/(InMAX-InMIN))+OutMIN);
}
//
